<template>
  <div class="order-correction-route">
    <div
      v-for="(point, index) in route"
      :key="index + point.addressTitle"
    >
      <template v-if="isReadonly">
        <RoutePoint
          :point="point"
          :is-readonly="isReadonly"
          @change="onChangePoint(index, $event)"
        />
      </template>
      <template v-else>
        <ObDrop
          @drop="onDrop(index, $event)"
        >
          <ObDrag
            :transferData="{
            fromItemIndex: index,
          }"
          >
            <RoutePoint
              :point="point"
              :is-readonly="isReadonly"
              :is-removable="route && route.length > 2"
              @change="onChangePoint(index, $event)"
              @remove="onRemovePoint(index)"
            />
          </ObDrag>
        </ObDrop>
      </template>
    </div>
    <template v-if="!isReadonly">
      <button
        class="add-point-button"
        @click="onAddPoint"
      >
        <i class="icon plus" />
        <span>Добавить точку</span>
      </button>
    </template>
  </div>
</template>

<script>
import ObDrag from 'common-components/src/obComponents/obDrag'
import ObDrop from 'common-components/src/obComponents/obDrop'
import RoutePoint from '@/components/Order/orderItem/services/nonFinancialAdjustment/route/point'
import cloneDeep from 'clone-deep'

const POINT_MODEL = {
  ordinal: '',
  direction: 'FROM',
  addressTitle: '',
  slotStartAt: '',
  slotEndAt: '',
}

export default {
  name: 'OrderCorrectionRoute',
  components: {
    ObDrag,
    ObDrop,
    RoutePoint
  },
  props: {
    route: {
      type: Array,
      default: () => []
    },
    isReadonly: {
      type: Boolean,
      default: false
    }
  },
  methods: {
    onChangeField (path, value) {
      this.$emit('change', { path, value })
    },
    onDrop (index, $event) {
      let result = cloneDeep(this.route)
      const { fromItemIndex } = $event
      const itemToMove = result.splice(fromItemIndex, 1)[0]
      result.splice(index, 0, itemToMove)

      this.onChangeField('', result)
    },
    onAddPoint () {
      let newRoute = cloneDeep(this.route)

      newRoute.push({ ...POINT_MODEL })
      this.onChangeField('', newRoute)
    },
    onChangePoint (index, { key, value }) {
      let newRoute = cloneDeep(this.route)

      newRoute[index][key] = value
      this.onChangeField('', newRoute)
    },
    onRemovePoint (index) {
      let newRoute = cloneDeep(this.route)

      newRoute.splice(index, 1)
      this.onChangeField('', newRoute)
    }
  },
}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";

.order-correction-route {
  .add-point-button {
    display: flex;
    align-items: center;
    margin: 15px 0 30px 0;
    padding: 0;
    border: none;
    background-color: transparent;
    outline: none;
    cursor: pointer;
    @include font-mixin(14px, 16px, 400, $color-blue-navy-blue);
    &:hover {
      opacity: 0.8;
    }
    .icon {
      margin-right: 6px;
      font-size: 16px;
    }
  }
  &::v-deep {
    .ob-draggable {
      position: relative;
      .drag-wrap {
        position: absolute;
        left: 12px;
        top: 22px;
        .icon {
          font-size: 24px;
          &::before {
            color: $color-blue-navy-blue;
          }
        }
      }
    }
  }
}
</style>